package org.ninjasoft.rovr.ui;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.EmptyBorder;
import org.ninjasoft.rovr.map.Mapper;
import org.ninjasoft.rovr.map.MapChangeListener;
import org.ninjasoft.rovr.net.MovementListener;

public class MapFrame extends JPanel implements MapChangeListener {
    private boolean initialized = false;
    private Actions actions = new Actions();
    private Mapper mapper;
    private JTextArea mapArea;

    public MapFrame(Mapper mapper) {
    	this.mapper = mapper;
    	initialize();
    }
    
    public void initialize() {
        initializeGui();
        initializeEvents();
    }

    private void initializeGui() {
        if (initialized)
            return;
        initialized = true;
        this.setSize(500, 400);
        Dimension windowSize = this.getSize();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        this.setLocation(screenSize.width/2 - windowSize.width/2, screenSize.height/2 - windowSize.height/2);
        this.setLayout(new BorderLayout());
        mapArea = new JTextArea();
        mapArea.setEditable(false);
        mapArea.setForeground(Color.BLACK);
        mapArea.setBackground(Color.WHITE);
        mapArea.setFont(new Font("Monospaced", 0, 8));
        this.add(new JScrollPane(mapArea), BorderLayout.CENTER);
    }
    
    private void initializeEvents() {
    }
    
    public class Actions implements ActionListener {
		public void actionPerformed(ActionEvent e) {
            String command = e.getActionCommand();
            command = command == null ? "" : command;
            // TODO: add if...if else... for action commands
        
        }
    }
    
    public void mapChanged() {
    	String map = "";
    	for (int y = mapper.miny; y<= mapper.maxy; y++) {
    		for (int x = mapper.minx; x<= mapper.maxx; x++) {
    			if ((y == mapper.posy) && (x == mapper.posx))
    				map += "@";	
			    else if (mapper.grid[x][y] == 0)
    				map += " ";
    			else if (mapper.grid[x][y] == 1)
    				map += "#";
    			else if (mapper.grid[x][y] == 2)
    				map += ".";
    		}
    		map += "\n";
    	}
    	this.mapArea.setText(map);
    }

	public synchronized void addKeyListener(KeyListener l) {
		super.addKeyListener(l);
		mapArea.addKeyListener(l);
	}
}
